%% This program is used to solve the moment of method and the characteristic mode problem, 
%    also to optimize the feeding position and get the feeding information, 
%      including position, amplitude and phase
%   steps: 1.Obtain the mesh generation information of the desired shape
%   using Matlab tools or something else;
%          2.Solve the MOM probelm;
%          3.Solve the CMs probelm;
%          4.Optimize the feeding position and get the feeding information;
%          5.Draw the current distribution.
clc;clear all;close all;
% %ǰļµļжúĿ¼
addpath(genpath(pwd));

%% ǰ׼
% ݵԤ
load('Add'); %load('AddCut');    %Add and AddCut are respect to Antenna III before and after Truncation
[s1 s2]=size(p);    
if(s1==2)               %άݻΪһά
    p(3,:)=0;           
end

%ÿεĵ꣨α˳洢
TrianglesTotal=length(t);              %ܵθ
for m=1:TrianglesTotal
   N=t(1:3,m);                         %mζӦڵıţpѰҶӦֵ
   Vec1=p(:,N(1))-p(:,N(2));           %ɽڵ2ָڵ1
   Vec2=p(:,N(3))-p(:,N(2));           %ɽڵ2ָڵ3
   Area(m) =norm(cross(Vec1,Vec2))/2;  %
   Center(:,m)=1/3*sum(p(:,N),2);      %õǵÿдһڵ꣬پּĵ
end

%ҵй(Ǳ߽ߣñΪεı)
Edge_=[];                      %EdgeTotalо󣬴洢ڵı
n=0;                           %
for m=1:TrianglesTotal
    N=t(1:3,m);                %mζӦڵıţpѰҶӦֵ
    for k=m+1:TrianglesTotal   %
        M=t(1:3,k);            %kζӦڵıţpѰҶӦֵ
        a=1-all([N-M(1) N-M(2) N-M(3)]); %allÿǷȫΪ0Ԫأȫ0򷵻1ȫ0ʾkĳһڵmνڵغ
        if(sum(a)==2)          %mkڵغ  й
            n=n+1;             %1
            Edge_=[Edge_ M(find(a))]; %ߵż¼
            TrianglePlus(n)=m;        %mαΪǰαŴ洢ģ
            TriangleMinus(n)=k;       %kαΪǰαŴ洢ģ
        end
    end
end
EdgesTotal=length(Edge_);             %ߵ

%ظʱȥظ
Edge__=[Edge_(2,:); Edge_(1,:)];%һк͵ڶл
Remove=[];
for m=1:EdgesTotal
    Edge_m=repmat(Edge_(:,m),[1 EdgesTotal]);%ظm
    Ind1=any(Edge_  -Edge_m);   %һΪ0anyΪжÿǷ0ֵ0
    Ind2=any(Edge__ -Edge_m);
    A=find(Ind1.*Ind2==0);
    if(length(A)==3)            %Դһ
        Out=find(t(4,TrianglePlus(A))==t(4,TriangleMinus(A)));
        Remove=[Remove A(Out)];
    end
end
Edge_(:,Remove)         =[];
TrianglePlus(Remove)    =[];
TriangleMinus(Remove)   =[];
EdgesTotal=length(Edge_);

%ÿߵĳ
for m=1:EdgesTotal   
   EdgeLength(m)=norm(p(:,Edge_(1,m))-p(:,Edge_(2,m)));   %߱Ŵ洢
end

%ÿ9εе
IMT=[];
for m=1:TrianglesTotal
    n1=t(1,m);%mεĵһڵ
    n2=t(2,m);%mεĵڶڵ
    n3=t(3,m);%mεĵڵ
    M=Center(:,m); %mεĵڵ
    r1=    p(:,n1);%mεĵһڵάλ
    r2=    p(:,n2);%mεĵڶڵάλ
    r3=    p(:,n3);%mεĵڵάλ
    r12=r2-r1;   %һڵָڶڵ
    r23=r3-r2;   %ڶڵָڵ
    r13=r3-r1;   %һڵָڵ
    C1=r1+(1/3)*r12;   %12ڵ֮1/3ĵ
    C2=r1+(2/3)*r12;   %12ڵ֮2/3ĵ
    C3=r2+(1/3)*r23;   %23ڵ֮1/3ĵ
    C4=r2+(2/3)*r23;   %23ڵ֮2/3ĵ
    C5=r1+(1/3)*r13;   %13ڵ֮1/3ĵ
    C6=r1+(2/3)*r13;   %13ڵ֮2/3ĵ
    a1=1/3*(C1+C5+r1); %һεе
    a2=1/3*(C1+C2+M);
    a3=1/3*(C2+C3+r2);
    a4=1/3*(C2+C3+M);
    a5=1/3*(C3+C4+M);
    a6=1/3*(C1+C5+M);
    a7=1/3*(C5+C6+M);
    a8=1/3*(C4+C6+M);
    a9=1/3*(C4+C6+r3);
    Center_(:,:,m)=...
        [a1 a2 a3 a4 a5 a6 a7 a8 a9];
end
%T+ɶ㵽ĵάڼΣ
%ά1:9ζӦĵڼΣһά13¼ε
for m=1:EdgesTotal
    NoPlus=TrianglePlus(m);   %TrianglePlus¼tе
    n1=t(1,NoPlus);           %mеһڵţpҵλ
    n2=t(2,NoPlus);
    n3=t(3,NoPlus); 
    %ҳɽڵ
    if((n1~=Edge_(1,m))&(n1~=Edge_(2,m))) NODE=n1; end;
    if((n2~=Edge_(1,m))&(n2~=Edge_(2,m))) NODE=n2; end;
    if((n3~=Edge_(1,m))&(n3~=Edge_(2,m))) NODE=n3; end;
    FreeVertex=p(:,NODE);   %ɽڵλ
    
    RHO_Plus(:,m)   =+Center(:,NoPlus)-FreeVertex;  %ɶָĵ
    RHO__Plus(:,:,m)  =...
        +Center_(:,:,NoPlus)-repmat(FreeVertex,[1 9]);%ɶָ9ĵ
end
% T-ɶ㵽ĵάڼΣ
%ά1:9ζӦĵڼΣһά13¼ε
for m=1:EdgesTotal
    NoMinus=TriangleMinus(m);
    n1=t(1,NoMinus);
    n2=t(2,NoMinus);
    n3=t(3,NoMinus);
    if((n1~=Edge_(1,m))&(n1~=Edge_(2,m))) NODE=n1; end;
    if((n2~=Edge_(1,m))&(n2~=Edge_(2,m))) NODE=n2; end;
    if((n3~=Edge_(1,m))&(n3~=Edge_(2,m))) NODE=n3; end;
    FreeVertex=p(:,NODE);
    
    RHO_Minus(:,m)   =-Center(:,NoMinus) +FreeVertex;
    RHO__Minus(:,:,m)=...
        -Center_(:,:,NoMinus)+repmat(FreeVertex,[1 9]);
end

% Ų/Ҫ޸Ļ߱
epsilon_    =8.854e-012;
mu_         =1.257e-006;
%  
c_          =1/sqrt(epsilon_*mu_);
%  ɿռ迹 
eta_=sqrt(mu_/epsilon_);



%% һЩϵimpmet
V=zeros(EdgesTotal,1);
f=400e6;
omega       =2*pi*f;
k0          =omega/c_;
K           =1i*k0;
omega       =2*pi*f;
Constant1   =mu_/(4*pi);
Constant2   =-1/(4*pi*omega*epsilon_);
Factor      =1/9;
FactorA     =Factor*(omega*EdgeLength/4)*Constant1;  %Ӧ2.2ʽڵһϵ
FactorFi    =Factor*EdgeLength*Constant2;%Ӧ2.2ʽڵڶϵ
%ϸϵο2.2-2.4ʽϵ
for m=1:EdgesTotal
    RHO_P(:,:,m)=repmat(RHO_Plus(:,m),[1 9]);   %[3 9 EdgesTotal]  %Ϊ֮׼
    RHO_M(:,:,m)=repmat(RHO_Minus(:,m),[1 9]);  %[3 9 EdgesTotal]
end
FactorA=FactorA.';  %
FactorFi=FactorFi.';

[Xe]=  impmetXe( EdgesTotal,TrianglesTotal,...
    EdgeLength,K,...
    Center,Center_,...
    TrianglePlus,TriangleMinus,...
    RHO_P,RHO_M,...
    RHO__Plus,RHO__Minus,...
    FactorA,FactorFi);
[Xm]=  impmetXm( EdgesTotal,TrianglesTotal,...
    EdgeLength,K,...
    Center,Center_,...
    TrianglePlus,TriangleMinus,...
    RHO_P,RHO_M,...
    RHO__Plus,RHO__Minus,...
    FactorA,FactorFi);

%% MoMʽ
Z=  impmet( EdgesTotal,TrianglesTotal,...
    EdgeLength,K,...
    Center,Center_,...
    TrianglePlus,TriangleMinus,...
    RHO_P,RHO_M,...
    RHO__Plus,RHO__Minus,...
    FactorA*1i,-FactorFi/1i);
Z=(Z+Z.')/2;
R=real(Z);
Xe=(Xe+Xe.')/4;  %Чֵ+2wWe1/2
Xm=(Xm+Xm.')/4;

[v,d]=eig(R,Xe+Xm);
d=sum(d,1);
Q=abs(1./d);
[Qsort,seq]=sort(Q);
%% ģʽģʽŻ
ExNum=seq(1);     %ģʽţQģ
Isti=v(:,ExNum);  %Ҫģʽ
% AĲ
Asti=Isti'*R*((Z)\diag(EdgeLength));
Asti=abs(Asti);
[ans,seqAsti]=sort(Asti,'descend');%seqAstiΪAstiСݵĻԪ
NumofSti=floor(EdgesTotal*0.1);   %λø
Qsti=[];  %ÿλöӦQ
Relation=[];  %ÿдһλ¼ģʽҪģʽĹȣ
Jodemain=v(:,seq(1:9));   %Ҫģʽ/QС
BestQ=[];  %¼QֵһΪģڶΪ㣩
BestI=[];%һΪģڶΪ㣩
BestV=zeros(EdgesTotal,2);  %¼QֵӦĵֲһΪģڶΪ㣩
for i=1:NumofSti
    V=zeros(EdgesTotal,1);
    V(seqAsti(i))=1*EdgeLength(seqAsti(i));    %ñߵѹ  Чֵ 
    I(:,i) = Z\V;
    Qsti(i)=(I(:,i)'*(Xe+Xm)*I(:,i))/(I(:,i)'*R*I(:,i));   %ڼQ<0Ӧų
    Coefficient=abs(Jodemain\I(:,i));
    Relation(i,:)=Coefficient/Coefficient(find(seq==ExNum));
    Se=find(V~=0);
        for ii=1:size(Se,1)
            Impedance11(i,ii)=V(Se(ii))/(I(Se(ii),i)*EdgeLength(Se(ii)));
        end
end
%ų 
for i=1:NumofSti
    Wp=find(real(Qsti)<0);
    Qsti(Wp)=inf;   %ڼQ<0Ӧų
    Relation(Wp,:)=inf*Relation(Wp,:);
end
%¼ŵQز
[ans,BestSeq]=min(abs(Qsti));
BestQ(1)=ans;
BestV(seqAsti(BestSeq),1)=1; 
BestI(:,1)=I(:,BestSeq); 

Qsti1=[];  %ÿλöӦQ+
Relation1=[];  %ÿдһλ¼ģʽҪģʽĹȣ+
V1=[];
Sign=size(find(Relation(BestSeq,:)>0.6+1e-6),2);%0Ѿܺãûиߴģļϵȼģʽϵʱ
if(Sign==0)  
    null;
else   %ģʽ
    for i=1:NumofSti
        Num2=sort(Relation(i,2:end),'descend');
        Depress=1;  %ģʽ
        NumRest=find(Relation(i,2:end)>=Num2(Depress)-1e-8)+1; %λҪƵģʽ
        a=[1;1e-6*ones(size(NumRest,2),1)]; %ϵ,ȥ1
        Jmod1=v(:,ExNum);   %ǵģʽ
        for j=1:1:size(NumRest,2)
            if(NumRest(j)==find(seq==ExNum))
               continue;
            else
                Jmod1(:,end+1)=Jodemain(:,NumRest(j));
            end
        end
        A1=Jmod1'*R*((Z)\diag(EdgeLength));
        V1(:,i)=A1\a;   %QstiǴĵطʾȲ㣬ù
        V1(:,i)=(V1(:,i)/max(abs(V1(:,i))));
        I1(:,i) = Z\(V1(:,i).*EdgeLength');
        Qsti1(i)=(I1(:,i)'*(Xe+Xm)*I1(:,i))/(I1(:,i)'*R*I1(:,i));   %ڼQ<0Ӧų
        Se=find(V1(:,i)~=0);
        for ii=1:size(Se,1)
            FeedPower(i,ii)=1/2*real(I1(Se(ii),i)*conj(V1(Se(ii),i)));
            Impedance(i,ii)=V1(Se(ii),i)/(I1(Se(ii),i)*EdgeLength(Se(ii)));
        end
        Coefficient=abs(Jodemain\I1(:,i));
        Relation1(i,:)=Coefficient/Coefficient(find(seq==ExNum));
    end
end
%ų
for i=1:NumofSti
    Wp=find(real(Qsti1)<0);
    Qsti1(Wp)=inf;   %ڼQ<0Ӧų
    Relation1(Wp,:)=inf*Relation1(Wp,:);
end
%¼ŵQز
[ans,BestSeq1]=min(abs(Qsti1));
BestQ(2)=ans;
BestV(:,2)=V1(:,BestSeq1);
BestI(:,2)=I1(:,BestSeq1);    

% figure(1)
% plot(1:EdgesTotal,BestV(:,1));
% xlabel('Triangular basis number','fontsize',13)
% ylabel('Feed voltage/V','fontsize',13)
% figure(2)
% plot(1:EdgesTotal,BestV(:,2));
% xlabel('Triangular basis number','fontsize',13)
% ylabel('Feed voltage/V','fontsize',13)

%% λúλϢ

PositionV1=[];
SS=find(BestV(:,1)>0);
Node1=Edge_(1,SS);
Node2=Edge_(2,SS);
PositionV1(1,:)=p(:,Node1);
PositionV1(2,:)=p(:,Node2);
Impedance1=BestV(SS,1)/(BestI(SS,1)*EdgeLength(SS))
%
Impedance2=[]; 
PositionV2=[];
ManyV=[];%һΪһȣڶΪӦλ
SS1=find(BestV(:,2)~=0);
for i=1:1:size(SS1,1)
    Node1=Edge_(1,SS1(i));
    Node2=Edge_(2,SS1(i));
    PositionV2(i,1:3)=p(:,Node1);
    PositionV2(i,4:6)=p(:,Node2);
    ManyV(1,i)=abs(BestV(SS1(i),2));
    ManyV(2,i)=angle(BestV(SS1(i),2))*180/pi;
end
ManyV(1,:)=ManyV(1,:)/max(ManyV(1,:));
II=Z\(BestV(:,2).*EdgeLength');
% Impedance2(1)=BestV(SS1(1),2)/II(SS1(1));
% Impedance2(2)=BestV(SS1(2),2)/II(SS1(2));
% Impedance2(3)=BestV(SS1(3),2)/II(SS1(3));
Qnew=II'*(Xe+Xm)*II/(II'*(R)*II)



  %% ÿζӦĵܶȲʸͼ
Index=find(t(4,:)<=1);
Triangles=length(Index);
for k=1:Triangles
    i=[0 0 0]';
    for m=1:EdgesTotal
        IE=v(m,seq(1))*EdgeLength(m);
        if(TrianglePlus(m)==k)  %kڵmεԪбΪT+
            i=i+IE*RHO_Plus(:,m)/(2*Area(TrianglePlus(m)));%ϵ
        end
        if(TriangleMinus(m)==k)
            i=i+IE*RHO_Minus(:,m)/(2*Area(TriangleMinus(m)));
        end
    end
     Current(:,k)=i;      
end
l=[];
r=[0,-1,0
    0.3,-0.2,0
    -0.1,-0.36,0
    1 0 0
    0 1 0
    -1 0 0
    0 1 0
    -0.3 0.2 0 
    -1 0 0]';
%ʱ뷽Ϊ
for m=1:Triangles
    N=t(1:3,m);
    XX(1:3,m)=[p(1,N)]';
    YY(1:3,m)=[p(2,N)]';  
    Cen(1,m)=mean(XX(:,m));
    Cen(2,m)=mean(YY(:,m));
    if(Cen(1,m)<=0.0005&&Cen(2,m)>=-0.04973)
        l(m)=abs(Cen(2,m));
        if(dot(Current(:,m),r(:,1))>0)
            CurrentNorm(m)=norm(Current(:,m));
        else
            CurrentNorm(m)=-norm(Current(:,m));
        end
        
    elseif(Cen(1,m)<0.030581&&Cen(2,m)>=-0.07&&Cen(2,m)<-0.04973)
        l(m)=sqrt((Cen(1,m)-0.00025)^2+(Cen(2,m)+0.05)^2)+0.04973;
        if(dot(Current(:,m),r(:,2))>0)
            CurrentNorm(m)=norm(Current(:,m));
        else
            CurrentNorm(m)=-norm(Current(:,m));
        end
        
    elseif(Cen(1,m)<0.030581&&Cen(1,m)>=0.02&&Cen(2,m)>-0.1055&&Cen(2,m)<-0.069784)
        l(m)=sqrt((Cen(1,m)-0.03)^2+(Cen(2,m)+0.07)^2)+0.08579;
        if(dot(Current(:,m),r(:,3))>0)
            CurrentNorm(m)=norm(Current(:,m));
        else
            CurrentNorm(m)=-norm(Current(:,m));
        end
        
     elseif(Cen(1,m)<0.106&&Cen(1,m)>=0.02&&Cen(2,m)>-0.106&&Cen(2,m)<-0.1055)
        l(m)=sqrt((Cen(1,m)-0.02)^2+(Cen(2,m)+0.106)^2)+0.12315;
        if(dot(Current(:,m),r(:,4))>0)
            CurrentNorm(m)=norm(Current(:,m));
        else
            CurrentNorm(m)=-norm(Current(:,m));
        end
        
     elseif(Cen(1,m)<0.106&&Cen(1,m)>=0.1055&&Cen(2,m)>-0.1055&&Cen(2,m)<-0.06)
        l(m)=sqrt((Cen(1,m)-0.1055)^2+(Cen(2,m)+0.1055)^2)+0.20915;
        if(dot(Current(:,m),r(:,5))>0)
            CurrentNorm(m)=norm(Current(:,m));
        else
            CurrentNorm(m)=-norm(Current(:,m));
        end
        
      elseif(Cen(1,m)<0.1055&&Cen(1,m)>=0.0695&&Cen(2,m)>-0.0605&&Cen(2,m)<=-0.06)
        l(m)=sqrt((Cen(1,m)-0.1055)^2+(Cen(2,m)+0.0605)^2)+0.25465;
        if(dot(Current(:,m),r(:,6))>0)
            CurrentNorm(m)=norm(Current(:,m));
        else
            CurrentNorm(m)=-norm(Current(:,m));
        end  
        
        elseif(Cen(1,m)<0.07&&Cen(1,m)>=0.0695&&Cen(2,m)>-0.06&&Cen(2,m)<=-0.02)
        l(m)=sqrt((Cen(1,m)-0.07)^2+(Cen(2,m)+0.06)^2)+0.29065;
        if(dot(Current(:,m),r(:,7))>0)
            CurrentNorm(m)=norm(Current(:,m));
        else
            CurrentNorm(m)=-norm(Current(:,m));
        end  
        
        elseif(Cen(1,m)<0.07&&Cen(1,m)>=0.04&&Cen(2,m)>-0.02&&Cen(2,m)<0)
        l(m)=sqrt((Cen(1,m)-0.07)^2+(Cen(2,m)+0.02)^2)+0.33065;
        if(dot(Current(:,m),r(:,8))>0)
            CurrentNorm(m)=norm(Current(:,m));
        else
            CurrentNorm(m)=-norm(Current(:,m));
        end  
        
        elseif(Cen(1,m)<0.04&&Cen(1,m)>=0.0005&&Cen(2,m)>-0.0005&&Cen(2,m)<0)
        l(m)=sqrt((Cen(1,m)-0.04)^2+(Cen(2,m))^2)+0.36671;
        if(dot(Current(:,m),r(:,9))>0)
            CurrentNorm(m)=norm(Current(:,m));
        else
            CurrentNorm(m)=-norm(Current(:,m));
        end  
    else
        l(m)=0;
        CurrentNorm(m)=norm(Current(:,m));
    end
    
end
Jmax=max(CurrentNorm);
MaxCurrent=strcat(num2str(Jmax),'[A/m]') %ֵ
CurrentNorm1=CurrentNorm/(max(abs(CurrentNorm)));%Ĺһ
figure(3)
plot(l/(c_/f),abs(CurrentNorm1),'o')
xlabel('s/{\lambda}','fontsize',13)
ylabel('Normalized I','fontsize',13)

 %% ÿζӦĵܶȲʸͼ
Index=find(t(4,:)<=1);
Triangles=length(Index);
for k=1:Triangles
    i=[0 0 0]';
    for m=1:EdgesTotal
        IE=BestI(m,2)*EdgeLength(m);
        if(TrianglePlus(m)==k)  %kڵmεԪбΪT+
            i=i+IE*RHO_Plus(:,m)/(2*Area(TrianglePlus(m)));%ϵ
        end
        if(TriangleMinus(m)==k)
            i=i+IE*RHO_Minus(:,m)/(2*Area(TriangleMinus(m)));
        end
    end
     Current(:,k)=i;      
end
l=[];
r=[0,-1,0
    0.3,-0.2,0
    -0.1,-0.36,0
    1 0 0
    0 1 0
    -1 0 0
    0 1 0
    -0.3 0.2 0 
    -1 0 0]';
%ʱ뷽Ϊ
for m=1:Triangles
    N=t(1:3,m);
    XX(1:3,m)=[p(1,N)]';
    YY(1:3,m)=[p(2,N)]';  
    Cen(1,m)=mean(XX(:,m));
    Cen(2,m)=mean(YY(:,m));
    if(Cen(1,m)<=0.0005&&Cen(2,m)>=-0.04973)
        l(m)=abs(Cen(2,m));
        if(dot(Current(:,m),r(:,1))>0)
            CurrentNorm(m)=norm(Current(:,m));
        else
            CurrentNorm(m)=-norm(Current(:,m));
        end
        
    elseif(Cen(1,m)<0.030581&&Cen(2,m)>=-0.07&&Cen(2,m)<-0.04973)
        l(m)=sqrt((Cen(1,m)-0.00025)^2+(Cen(2,m)+0.05)^2)+0.04973;
        if(dot(Current(:,m),r(:,2))>0)
            CurrentNorm(m)=norm(Current(:,m));
        else
            CurrentNorm(m)=-norm(Current(:,m));
        end
        
    elseif(Cen(1,m)<0.030581&&Cen(1,m)>=0.02&&Cen(2,m)>-0.1055&&Cen(2,m)<-0.069784)
        l(m)=sqrt((Cen(1,m)-0.03)^2+(Cen(2,m)+0.07)^2)+0.08579;
        if(dot(Current(:,m),r(:,3))>0)
            CurrentNorm(m)=norm(Current(:,m));
        else
            CurrentNorm(m)=-norm(Current(:,m));
        end
        
     elseif(Cen(1,m)<0.106&&Cen(1,m)>=0.02&&Cen(2,m)>-0.106&&Cen(2,m)<-0.1055)
        l(m)=sqrt((Cen(1,m)-0.02)^2+(Cen(2,m)+0.106)^2)+0.12315;
        if(dot(Current(:,m),r(:,4))>0)
            CurrentNorm(m)=norm(Current(:,m));
        else
            CurrentNorm(m)=-norm(Current(:,m));
        end
        
     elseif(Cen(1,m)<0.106&&Cen(1,m)>=0.1055&&Cen(2,m)>-0.1055&&Cen(2,m)<-0.06)
        l(m)=sqrt((Cen(1,m)-0.1055)^2+(Cen(2,m)+0.1055)^2)+0.20915;
        if(dot(Current(:,m),r(:,5))>0)
            CurrentNorm(m)=norm(Current(:,m));
        else
            CurrentNorm(m)=-norm(Current(:,m));
        end
        
      elseif(Cen(1,m)<0.1055&&Cen(1,m)>=0.0695&&Cen(2,m)>-0.0605&&Cen(2,m)<=-0.06)
        l(m)=sqrt((Cen(1,m)-0.1055)^2+(Cen(2,m)+0.0605)^2)+0.25465;
        if(dot(Current(:,m),r(:,6))>0)
            CurrentNorm(m)=norm(Current(:,m));
        else
            CurrentNorm(m)=-norm(Current(:,m));
        end  
        
        elseif(Cen(1,m)<0.07&&Cen(1,m)>=0.0695&&Cen(2,m)>-0.06&&Cen(2,m)<=-0.02)
        l(m)=sqrt((Cen(1,m)-0.07)^2+(Cen(2,m)+0.06)^2)+0.29065;
        if(dot(Current(:,m),r(:,7))>0)
            CurrentNorm(m)=norm(Current(:,m));
        else
            CurrentNorm(m)=-norm(Current(:,m));
        end  
        
        elseif(Cen(1,m)<0.07&&Cen(1,m)>=0.04&&Cen(2,m)>-0.02&&Cen(2,m)<0)
        l(m)=sqrt((Cen(1,m)-0.07)^2+(Cen(2,m)+0.02)^2)+0.33065;
        if(dot(Current(:,m),r(:,8))>0)
            CurrentNorm(m)=norm(Current(:,m));
        else
            CurrentNorm(m)=-norm(Current(:,m));
        end  
        
        elseif(Cen(1,m)<0.04&&Cen(1,m)>=0.0005&&Cen(2,m)>-0.0005&&Cen(2,m)<0)
        l(m)=sqrt((Cen(1,m)-0.04)^2+(Cen(2,m))^2)+0.36671;
        if(dot(Current(:,m),r(:,9))>0)
            CurrentNorm(m)=norm(Current(:,m));
        else
            CurrentNorm(m)=-norm(Current(:,m));
        end  
    else
        l(m)=0;
        CurrentNorm(m)=norm(Current(:,m));
    end
    
end
Jmax=max(CurrentNorm);
MaxCurrent=strcat(num2str(Jmax),'[A/m]') %ֵ
CurrentNorm1=CurrentNorm/(max(abs(CurrentNorm)));%Ĺһ
figure(4)
plot(l/(c_/f),abs(CurrentNorm1),'o')
xlabel('s/{\lambda}','fontsize',13)
ylabel('Normalized I','fontsize',13)

 %% ÿζӦĵܶȲʸͼ
Index=find(t(4,:)<=1);
Triangles=length(Index);
for k=1:Triangles
    i=[0 0 0]';
    for m=1:EdgesTotal
        IE=BestI(m,1)*EdgeLength(m);
        if(TrianglePlus(m)==k)  %kڵmεԪбΪT+
            i=i+IE*RHO_Plus(:,m)/(2*Area(TrianglePlus(m)));%ϵ
        end
        if(TriangleMinus(m)==k)
            i=i+IE*RHO_Minus(:,m)/(2*Area(TriangleMinus(m)));
        end
    end
     Current(:,k)=i;      
end
l=[];
r=[0,-1,0
    0.3,-0.2,0
    -0.1,-0.36,0
    1 0 0
    0 1 0
    -1 0 0
    0 1 0
    -0.3 0.2 0 
    -1 0 0]';
%ʱ뷽Ϊ
for m=1:Triangles
    N=t(1:3,m);
    XX(1:3,m)=[p(1,N)]';
    YY(1:3,m)=[p(2,N)]';  
    Cen(1,m)=mean(XX(:,m));
    Cen(2,m)=mean(YY(:,m));
    if(Cen(1,m)<=0.0005&&Cen(2,m)>=-0.04973)
        l(m)=abs(Cen(2,m));
        if(dot(Current(:,m),r(:,1))>0)
            CurrentNorm(m)=norm(Current(:,m));
        else
            CurrentNorm(m)=-norm(Current(:,m));
        end
        
    elseif(Cen(1,m)<0.030581&&Cen(2,m)>=-0.07&&Cen(2,m)<-0.04973)
        l(m)=sqrt((Cen(1,m)-0.00025)^2+(Cen(2,m)+0.05)^2)+0.04973;
        if(dot(Current(:,m),r(:,2))>0)
            CurrentNorm(m)=norm(Current(:,m));
        else
            CurrentNorm(m)=-norm(Current(:,m));
        end
        
    elseif(Cen(1,m)<0.030581&&Cen(1,m)>=0.02&&Cen(2,m)>-0.1055&&Cen(2,m)<-0.069784)
        l(m)=sqrt((Cen(1,m)-0.03)^2+(Cen(2,m)+0.07)^2)+0.08579;
        if(dot(Current(:,m),r(:,3))>0)
            CurrentNorm(m)=norm(Current(:,m));
        else
            CurrentNorm(m)=-norm(Current(:,m));
        end
        
     elseif(Cen(1,m)<0.106&&Cen(1,m)>=0.02&&Cen(2,m)>-0.106&&Cen(2,m)<-0.1055)
        l(m)=sqrt((Cen(1,m)-0.02)^2+(Cen(2,m)+0.106)^2)+0.12315;
        if(dot(Current(:,m),r(:,4))>0)
            CurrentNorm(m)=norm(Current(:,m));
        else
            CurrentNorm(m)=-norm(Current(:,m));
        end
        
     elseif(Cen(1,m)<0.106&&Cen(1,m)>=0.1055&&Cen(2,m)>-0.1055&&Cen(2,m)<-0.06)
        l(m)=sqrt((Cen(1,m)-0.1055)^2+(Cen(2,m)+0.1055)^2)+0.20915;
        if(dot(Current(:,m),r(:,5))>0)
            CurrentNorm(m)=norm(Current(:,m));
        else
            CurrentNorm(m)=-norm(Current(:,m));
        end
        
      elseif(Cen(1,m)<0.1055&&Cen(1,m)>=0.0695&&Cen(2,m)>-0.0605&&Cen(2,m)<=-0.06)
        l(m)=sqrt((Cen(1,m)-0.1055)^2+(Cen(2,m)+0.0605)^2)+0.25465;
        if(dot(Current(:,m),r(:,6))>0)
            CurrentNorm(m)=norm(Current(:,m));
        else
            CurrentNorm(m)=-norm(Current(:,m));
        end  
        
        elseif(Cen(1,m)<0.07&&Cen(1,m)>=0.0695&&Cen(2,m)>-0.06&&Cen(2,m)<=-0.02)
        l(m)=sqrt((Cen(1,m)-0.07)^2+(Cen(2,m)+0.06)^2)+0.29065;
        if(dot(Current(:,m),r(:,7))>0)
            CurrentNorm(m)=norm(Current(:,m));
        else
            CurrentNorm(m)=-norm(Current(:,m));
        end  
        
        elseif(Cen(1,m)<0.07&&Cen(1,m)>=0.04&&Cen(2,m)>-0.02&&Cen(2,m)<0)
        l(m)=sqrt((Cen(1,m)-0.07)^2+(Cen(2,m)+0.02)^2)+0.33065;
        if(dot(Current(:,m),r(:,8))>0)
            CurrentNorm(m)=norm(Current(:,m));
        else
            CurrentNorm(m)=-norm(Current(:,m));
        end  
        
        elseif(Cen(1,m)<0.04&&Cen(1,m)>=0.0005&&Cen(2,m)>-0.0005&&Cen(2,m)<0)
        l(m)=sqrt((Cen(1,m)-0.04)^2+(Cen(2,m))^2)+0.36671;
        if(dot(Current(:,m),r(:,9))>0)
            CurrentNorm(m)=norm(Current(:,m));
        else
            CurrentNorm(m)=-norm(Current(:,m));
        end  
    else
        l(m)=0;
        CurrentNorm(m)=norm(Current(:,m));
    end
    
end
Jmax=max(CurrentNorm);
MaxCurrent=strcat(num2str(Jmax),'[A/m]') %ֵ
CurrentNorm1=CurrentNorm/(max(abs(CurrentNorm)));%Ĺһ
figure(56)
plot(l/(c_/f),abs(CurrentNorm1),'o')
xlabel('s/{\lambda}','fontsize',13)
ylabel('Normalized I','fontsize',13)
%% ÿζӦҪģʽʸͼ ıseg
Index=find(t(4,:)<=1);
Triangles=length(Index);
CurrentVector=[];
for k=1:Triangles
    i=[0 0 0]';
    for m=1:EdgesTotal
        IE=v(m,seq(1))*EdgeLength(m);
        if(TrianglePlus(m)==k)  %kڵmεԪбΪT+
            i=i+IE*RHO_Plus(:,m)/(2*Area(TrianglePlus(m)));%ϵ
        end
        if(TriangleMinus(m)==k)
            i=i+IE*RHO_Minus(:,m)/(2*Area(TriangleMinus(m)));
        end
    end
    CurrentNorm(k)=abs(norm(i));   %ɼΪÿеĵ֮ɺʸͼ
    CurrentVector(1:2,k)=i(1:2);
end

Jmax=max(CurrentNorm);
MaxCurrent=strcat(num2str(Jmax),'[A/m]') %ֵ
CurrentNorm1=CurrentNorm/max(CurrentNorm);%Ĺһ
for m=1:Triangles
    N=t(1:3,m);
    XX(1:3,m)=[p(1,N)]';
    YY(1:3,m)=[p(2,N)]';  
end
C=repmat(CurrentNorm1,3,1);
figure(15)
h=fill(XX,YY,C); %ƶάʱֻҪZȥ
colormap gray;
colormap(flipud(colormap))
axis('equal');
rotate3d
hold on;
quiver(Center(1,:),Center(2,:),CurrentVector(1,:),CurrentVector(2,:),3,'color', 'r', 'linewidth', 1.5,'maxheadsize',1.2)
xlabel('y,m','fontsize',13)
ylabel('x,m','fontsize',13)
%% ÿζӦҪģʽʸͼ ıseg
Index=find(t(4,:)<=1);
Triangles=length(Index);
CurrentVector=[];
for k=1:Triangles
    i=[0 0 0]';
    for m=1:EdgesTotal
        IE=BestI(m,2)*EdgeLength(m);
        if(TrianglePlus(m)==k)  %kڵmεԪбΪT+
            i=i+IE*RHO_Plus(:,m)/(2*Area(TrianglePlus(m)));%ϵ
        end
        if(TriangleMinus(m)==k)
            i=i+IE*RHO_Minus(:,m)/(2*Area(TriangleMinus(m)));
        end
    end
    CurrentNorm(k)=abs(norm(i));   %ɼΪÿеĵ֮ɺʸͼ
    CurrentVector(1:2,k)=i(1:2);
end

Jmax=max(CurrentNorm);
MaxCurrent=strcat(num2str(Jmax),'[A/m]') %ֵ
CurrentNorm1=CurrentNorm/max(CurrentNorm);%Ĺһ
for m=1:Triangles
    N=t(1:3,m);
    XX(1:3,m)=[p(1,N)]';
    YY(1:3,m)=[p(2,N)]';  
end
C=repmat(CurrentNorm1,3,1);
figure(16)
h=fill(XX,YY,C); %ƶάʱֻҪZȥ
colormap gray;
colormap(flipud(colormap))
axis('equal');
rotate3d
hold on;
quiver(Center(1,:),Center(2,:),CurrentVector(1,:),CurrentVector(2,:),0.5,'color', 'r', 'linewidth', 1.5,'maxheadsize',0.1)
xlabel('y,m','fontsize',13)
ylabel('x,m','fontsize',13)
%% ÿζӦҪģʽʸͼ ıseg
Index=find(t(4,:)<=1);
Triangles=length(Index);
CurrentVector=[];
for k=1:Triangles
    i=[0 0 0]';
    for m=1:EdgesTotal
        IE=BestI(m,1)*EdgeLength(m);
        if(TrianglePlus(m)==k)  %kڵmεԪбΪT+
            i=i+IE*RHO_Plus(:,m)/(2*Area(TrianglePlus(m)));%ϵ
        end
        if(TriangleMinus(m)==k)
            i=i+IE*RHO_Minus(:,m)/(2*Area(TriangleMinus(m)));
        end
    end
    CurrentNorm(k)=abs(norm(i));   %ɼΪÿеĵ֮ɺʸͼ
    CurrentVector(1:2,k)=i(1:2);
end

Jmax=max(CurrentNorm);
MaxCurrent=strcat(num2str(Jmax),'[A/m]') %ֵ
CurrentNorm1=CurrentNorm/max(CurrentNorm);%Ĺһ
for m=1:Triangles
    N=t(1:3,m);
    XX(1:3,m)=[p(1,N)]';
    YY(1:3,m)=[p(2,N)]';  
end
C=repmat(CurrentNorm1,3,1);
figure(17)
h=fill(XX,YY,C); %ƶάʱֻҪZȥ
colormap gray;
colormap(flipud(colormap))
axis('equal');
rotate3d
hold on;
quiver(Center(1,:),Center(2,:),CurrentVector(1,:),CurrentVector(2,:),3,'color', 'r', 'linewidth', 1.5,'maxheadsize',1.2)
xlabel('y,m','fontsize',13)
ylabel('x,m','fontsize',13)