function plate(L,W)
warning off

% f=30e6;         % working frequence
% lamda=3*1e8/f;   %wave length
% W=4*1e-3*lamda;       %Plate width (along the x-axis)
% L=0.15*lamda;         %Plate length (along the y-axis)
Nx=1;            %Discretization parameter (width)
Ny=72;           %Discretization parameter (length)

%Set vertexes
epsilon=1e-6;
M=1;
for i=1:Nx+1
    for j=1:Ny+1
        X(M)=W/2-(i-1)/Nx*W;
        Y(M)=L/2-(j-1)/Ny*L-epsilon*X(M);
        M=M+1;
    end
end

%Use Delaunay triangulation
TRI = delaunay(X,Y);
t=TRI';
t(4,:)=1;
p=[X; Y; zeros(1,length(X))];


%Save result
% save('E:\\Ӣ׫д\ʦһЩļ\żQֵ\Dipole\mesh\plate.mat', 'p','t') 
% viewer plate
% title('Antenna geometry','fontsize',15)
% xlabel('y,m','fontsize',13)
% ylabel('x,m','fontsize',13)
