%% This program is used to solve the moment of method and the characteristic mode problem, 
%    also to optimize the feeding position and get the feeding information, 
%      including position, amplitude and phase
%   steps: 1.Obtain the mesh generation information of the desired shape
%   using Matlab tools or something else;
%          2.Solve the MOM probelm;
%          3.Solve the CMs probelm;
%          4.Optimize the feeding position and get the feeding information;
%          5.Draw the current distribution.
clc;clear all;close all;
%ǰļµļжúĿ¼
addpath(genpath(pwd));

%% ǰ׼
% ݵԤ
load('mesh/ArbitraryShape');     %p t
[s1 s2]=size(p);    
if(s1==2)               %άݻΪһά
    p(3,:)=0;           
end

%ÿεĵ꣨α˳洢
TrianglesTotal=length(t);              %ܵθ
for m=1:TrianglesTotal 
   N=t(1:3,m);                         %mζӦڵıţpѰҶӦֵ
   Vec1=p(:,N(1))-p(:,N(2));           %ɽڵ2ָڵ1
   Vec2=p(:,N(3))-p(:,N(2));           %ɽڵ2ָڵ3
   Area(m) =norm(cross(Vec1,Vec2))/2;  %
   Center(:,m)=1/3*sum(p(:,N),2);      %õǵÿдһڵ꣬پּĵ
end

%ҵй(Ǳ߽ߣñΪεı)
Edge_=[];                      %EdgeTotalо󣬴洢ڵı
n=0;                           %
for m=1:TrianglesTotal
    N=t(1:3,m);                %mζӦڵıţpѰҶӦֵ
    for k=m+1:TrianglesTotal   %
        M=t(1:3,k);            %kζӦڵıţpѰҶӦֵ
        a=1-all([N-M(1) N-M(2) N-M(3)]); %allÿǷȫΪ0Ԫأȫ0򷵻1ȫ0ʾkĳһڵmνڵغ
        if(sum(a)==2)          %mkڵغ  й
            n=n+1;             %1
            Edge_=[Edge_ M(find(a))]; %ߵż¼
            TrianglePlus(n)=m;        %mαΪǰαŴ洢ģ
            TriangleMinus(n)=k;       %kαΪǰαŴ洢ģ
        end
    end
end
EdgesTotal=length(Edge_);             %ߵ

%ظʱȥظ
Edge__=[Edge_(2,:); Edge_(1,:)];%һк͵ڶл
Remove=[];
for m=1:EdgesTotal
    Edge_m=repmat(Edge_(:,m),[1 EdgesTotal]);%ظm
    Ind1=any(Edge_  -Edge_m);   %һΪ0anyΪжÿǷ0ֵ0
    Ind2=any(Edge__ -Edge_m);
    A=find(Ind1.*Ind2==0);
    if(length(A)==3)            %Դһ
        Out=find(t(4,TrianglePlus(A))==t(4,TriangleMinus(A)));
        Remove=[Remove A(Out)];
    end
end
Edge_(:,Remove)         =[];
TrianglePlus(Remove)    =[];
TriangleMinus(Remove)   =[];
EdgesTotal=length(Edge_);

%ÿߵĳ
for m=1:EdgesTotal   
   EdgeLength(m)=norm(p(:,Edge_(1,m))-p(:,Edge_(2,m)));   %߱Ŵ洢
end

%ÿ9εе
IMT=[];
for m=1:TrianglesTotal
    n1=t(1,m);%mεĵһڵ
    n2=t(2,m);%mεĵڶڵ
    n3=t(3,m);%mεĵڵ
    M=Center(:,m); %mεĵڵ
    r1=    p(:,n1);%mεĵһڵάλ
    r2=    p(:,n2);%mεĵڶڵάλ
    r3=    p(:,n3);%mεĵڵάλ
    r12=r2-r1;   %һڵָڶڵ
    r23=r3-r2;   %ڶڵָڵ
    r13=r3-r1;   %һڵָڵ
    C1=r1+(1/3)*r12;   %12ڵ֮1/3ĵ
    C2=r1+(2/3)*r12;   %12ڵ֮2/3ĵ
    C3=r2+(1/3)*r23;   %23ڵ֮1/3ĵ
    C4=r2+(2/3)*r23;   %23ڵ֮2/3ĵ
    C5=r1+(1/3)*r13;   %13ڵ֮1/3ĵ
    C6=r1+(2/3)*r13;   %13ڵ֮2/3ĵ
    a1=1/3*(C1+C5+r1); %һεе
    a2=1/3*(C1+C2+M);
    a3=1/3*(C2+C3+r2);
    a4=1/3*(C2+C3+M);
    a5=1/3*(C3+C4+M);
    a6=1/3*(C1+C5+M);
    a7=1/3*(C5+C6+M);
    a8=1/3*(C4+C6+M);
    a9=1/3*(C4+C6+r3);
    Center_(:,:,m)=...
        [a1 a2 a3 a4 a5 a6 a7 a8 a9];
end
%T+ɶ㵽ĵάڼΣ
%ά1:9ζӦĵڼΣһά13¼ε
for m=1:EdgesTotal
    NoPlus=TrianglePlus(m);   %TrianglePlus¼tе
    n1=t(1,NoPlus);           %mеһڵţpҵλ
    n2=t(2,NoPlus);
    n3=t(3,NoPlus); 
    %ҳɽڵ
    if((n1~=Edge_(1,m))&(n1~=Edge_(2,m))) NODE=n1; end;
    if((n2~=Edge_(1,m))&(n2~=Edge_(2,m))) NODE=n2; end;
    if((n3~=Edge_(1,m))&(n3~=Edge_(2,m))) NODE=n3; end;
    FreeVertex=p(:,NODE);   %ɽڵλ
    
    RHO_Plus(:,m)   =+Center(:,NoPlus)-FreeVertex;  %ɶָĵ
    RHO__Plus(:,:,m)  =...
        +Center_(:,:,NoPlus)-repmat(FreeVertex,[1 9]);%ɶָ9ĵ
end
% T-ɶ㵽ĵάڼΣ
%ά1:9ζӦĵڼΣһά13¼ε
for m=1:EdgesTotal
    NoMinus=TriangleMinus(m);
    n1=t(1,NoMinus);
    n2=t(2,NoMinus);
    n3=t(3,NoMinus);
    if((n1~=Edge_(1,m))&(n1~=Edge_(2,m))) NODE=n1; end;
    if((n2~=Edge_(1,m))&(n2~=Edge_(2,m))) NODE=n2; end;
    if((n3~=Edge_(1,m))&(n3~=Edge_(2,m))) NODE=n3; end;
    FreeVertex=p(:,NODE);
    
    RHO_Minus(:,m)   =-Center(:,NoMinus) +FreeVertex;
    RHO__Minus(:,:,m)=...
        -Center_(:,:,NoMinus)+repmat(FreeVertex,[1 9]);
end

% Ų/Ҫ޸Ļ߱
epsilon_    =8.854e-012;
mu_         =1.257e-006;
%  
c_          =1/sqrt(epsilon_*mu_);
%  ɿռ迹 
eta_=sqrt(mu_/epsilon_);



%% һЩϵimpmet
V=zeros(EdgesTotal,1);
f=1600e6;
omega       =2*pi*f;
k0          =omega/c_;
K           =1i*k0;
omega       =2*pi*f;
Constant1   =mu_/(4*pi);
Constant2   =-1/(4*pi*omega*epsilon_);
Factor      =1/9;
FactorA     =Factor*(omega*EdgeLength/4)*Constant1;  %Ӧ2.2ʽڵһϵ
FactorFi    =Factor*EdgeLength*Constant2;%Ӧ2.2ʽڵڶϵ
%ϸϵο2.2-2.4ʽϵ
for m=1:EdgesTotal
    RHO_P(:,:,m)=repmat(RHO_Plus(:,m),[1 9]);   %[3 9 EdgesTotal]  %Ϊ֮׼
    RHO_M(:,:,m)=repmat(RHO_Minus(:,m),[1 9]);  %[3 9 EdgesTotal]
end
FactorA=FactorA.';  %
FactorFi=FactorFi.';

[Xe]=  impmetXe( EdgesTotal,TrianglesTotal,...
    EdgeLength,K,...
    Center,Center_,...
    TrianglePlus,TriangleMinus,...
    RHO_P,RHO_M,...
    RHO__Plus,RHO__Minus,...
    FactorA,FactorFi);
[Xm]=  impmetXm( EdgesTotal,TrianglesTotal,...
    EdgeLength,K,...
    Center,Center_,...
    TrianglePlus,TriangleMinus,...
    RHO_P,RHO_M,...
    RHO__Plus,RHO__Minus,...
    FactorA,FactorFi);

%% MoMʽ
Z=  impmet( EdgesTotal,TrianglesTotal,...
    EdgeLength,K,...
    Center,Center_,...
    TrianglePlus,TriangleMinus,...
    RHO_P,RHO_M,...
    RHO__Plus,RHO__Minus,...
    FactorA*1i,-FactorFi/1i);
Z=(Z+Z.')/2;
R=real(Z);
Xe=(Xe+Xe.')/4;  %Чֵ+2wWe1/2
Xm=(Xm+Xm.')/4;

[v,d]=eig(imag(Z),R);
d=sum(d,1);
Q=abs(d);  %д Ҫģʽһ
[Qsort,seq]=sort(Q);

%% ģʽģʽŻ
ExNum=seq(1);     %ģʽţQģ
Isti=v(:,ExNum);  %Ҫģʽ
% AĲ
Asti=Isti'*R*((Z)\diag(EdgeLength));
Asti=abs(Asti);
[ans,seqAsti]=sort(Asti,'descend');%seqAstiΪAstiСݵĻԪ
NumofSti=floor(EdgesTotal*1);   %λø
Qsti=[];  %ÿλöӦQ
Relation=[];  %ÿдһλ¼ģʽҪģʽĹȣ
Jodemain=v(:,seq(1:9));   %Ҫģʽ/QС
BestQ=[];  %¼QֵһΪģڶΪ㣩
BestI=[];%һΪģڶΪ㣩
BestV=zeros(EdgesTotal,2);  %¼QֵӦĵֲһΪģڶΪ㣩
for i=1:NumofSti
    V=zeros(EdgesTotal,1);
    V(seqAsti(i))=1*EdgeLength(seqAsti(i));    %ñߵѹ  Чֵ 
    I(:,i) = Z\V;
    Qsti(i)=(I(:,i)'*(Xe)*I(:,i))/(I(:,i)'*Xm*I(:,i));   %ڼQ<0Ӧų
    Coefficient=abs(Jodemain\I(:,i));
    Relation(i,:)=Coefficient/Coefficient(find(seq==ExNum));
    Se=find(V~=0);
        for ii=1:size(Se,1)
            Impedance11(i,ii)=V(Se(ii))/(I(Se(ii),i)*EdgeLength(Se(ii))^2);
        end
end
%ų 
for i=1:NumofSti
    Wp=find(real(Qsti)<0);
    Qsti(Wp)=inf;   %ڼQ<0Ӧų
    Relation(Wp,:)=inf*Relation(Wp,:);
end
%¼ŵQز
[ans,BestSeq]=min(abs(Qsti-1));
BestQ(1)=abs(Qsti(BestSeq));
BestV(seqAsti(BestSeq),1)=1; 
BestI(:,1)=I(:,BestSeq); 

Qsti1=[];  %ÿλöӦQ+
Relation1=[];  %ÿдһλ¼ģʽҪģʽĹȣ+
V1=[];
Sign=1;%size(find(Relation(BestSeq,:)>0.2+1e-6),2);%0Ѿܺãûиߴģļϵȼģʽϵʱ
if(Sign==0)  
    null;
else   %ģʽ
    for i=1:NumofSti
        Num2=sort(Relation(i,2:end),'descend');
        Depress=1;  %ģʽ
        NumRest=find(Relation(i,2:end)>=Num2(Depress)-1e-8)+1; %λҪƵģʽ
        a=[1;1e-6*ones(size(NumRest,2),1)]; %ϵ,ȥ1
        Jmod1=v(:,ExNum);   %ǵģʽ
        for j=1:1:size(NumRest,2)
            if(NumRest(j)==find(seq==ExNum))
               continue;
            else
                Jmod1(:,end+1)=Jodemain(:,NumRest(j));
            end
        end
        A1=Jmod1'*R*((Z)\diag(EdgeLength));
        V1(:,i)=A1\a;   %QstiǴĵطʾȲ㣬ù
        V1(:,i)=(V1(:,i)/max(abs(V1(:,i))));
        I1(:,i) = Z\(V1(:,i).*EdgeLength');
        Qsti1(i)=(I1(:,i)'*(Xe)*I1(:,i))/(I1(:,i)'*Xm*I1(:,i));   %ڼQ<0Ӧų
        Se=find(V1(:,i)~=0);
        for ii=1:size(Se,1)
            FeedPower(i,ii)=1/2*real(I1(Se(ii),i)*conj(V1(Se(ii),i)));
            Impedance(i,ii)=V1(Se(ii),i)/(I1(Se(ii),i)*EdgeLength(Se(ii)));
        end
        Coefficient=abs(Jodemain\I1(:,i));
        Relation1(i,:)=Coefficient/Coefficient(find(seq==ExNum));
    end
end
%ų
for i=1:NumofSti
    Wp=find(real(Qsti1)<0);
    Qsti1(Wp)=inf;   %ڼQ<0Ӧų
    Relation1(Wp,:)=inf*Relation1(Wp,:);
end
%¼ŵQز
[ans,BestSeq1]=min(abs(Qsti1-1));
% BestSeq1=15;
BestQ(2)=Qsti1(BestSeq1);
BestV(:,2)=V1(:,BestSeq1);
BestI(:,2)=I1(:,BestSeq1);    

%% λúλϢ

PositionV1=[];
SS=find(BestV(:,1)>0);
Node1=Edge_(1,SS);
Node2=Edge_(2,SS);
PositionV1(1,:)=p(:,Node1);
PositionV1(2,:)=p(:,Node2);
Impedance1=BestV(SS,1)/(BestI(SS,1)*EdgeLength(SS))
%
Impedance2=[]; 
PositionV2=[];
ManyV=[];%һΪһȣڶΪӦλ
SS1=find(BestV(:,2)~=0);
for i=1:1:size(SS1,1)
    Node1=Edge_(1,SS1(i));
    Node2=Edge_(2,SS1(i));
    PositionV2(i,1:3)=p(:,Node1);
    PositionV2(i,4:6)=p(:,Node2);
    ManyV(1,i)=abs(BestV(SS1(i),2));
    ManyV(2,i)=angle(BestV(SS1(i),2))*180/pi;
end
ManyV(1,:)=ManyV(1,:)/max(ManyV(1,:));
II=Z\(BestV(:,2).*EdgeLength');
Impedance2(1)=BestV(SS1(1),2)/(II(SS1(1))*EdgeLength(SS1(1)));
Impedance2(2)=BestV(SS1(2),2)/(II(SS1(2))*EdgeLength(SS1(2)));

Qnew=II'*(Xe)*II/(II'*(Xm)*II)
BestI(:,1)'*(Xe)*BestI(:,1)
BestI(:,1)'*(Xm)*BestI(:,1)
Q1=BestI(:,1)'*(Xe+Xm)*BestI(:,1)/(BestI(:,1)'*(R)*BestI(:,1))
BestI(:,2)'*(Xe)*BestI(:,2)
BestI(:,2)'*(Xm)*BestI(:,2)
Q2=BestI(:,2)'*(Xe+Xm)*BestI(:,2)/(BestI(:,2)'*(R)*BestI(:,2))
BestQ
v(:,seq(1))'*(Xe)*v(:,seq(1))
v(:,seq(1))'*(Xm)*v(:,seq(1))
v(:,seq(1))'*(Xe)*v(:,seq(1))/(v(:,seq(1))'*(Xm)*v(:,seq(1)))
v(:,seq(1))'*(Xe+Xm)*v(:,seq(1))/(v(:,seq(1))'*(R)*v(:,seq(1)))
% 
% if BestQ(1)>BestQ(2)
%     S=2;
% else
%     S=1;
% end
% 
  %% ÿζӦĵܶȲʸͼ
Index=find(t(4,:)<=1);
Triangles=length(Index);
for k=1:Triangles
    i=[0 0 0]';
    for m=1:EdgesTotal
        IE=v(m,seq(1))*EdgeLength(m);
        if(TrianglePlus(m)==k)  %kڵmεԪбΪT+
            i=i+IE*RHO_Plus(:,m)/(2*Area(TrianglePlus(m)));%ϵ
        end
        if(TriangleMinus(m)==k)
            i=i+IE*RHO_Minus(:,m)/(2*Area(TriangleMinus(m)));
        end
    end
     Current(:,k)=i;      
end
l=[];
r=[0,-1,0
    0.3,-0.2,0
    -0.1,-0.36,0
    1 0 0
    0 1 0
    -1 0 0
    0 1 0
    -0.3 0.2 0 
    -1 0 0]';
%ʱ뷽Ϊ
for m=1:Triangles
    N=t(1:3,m);
    XX(1:3,m)=[p(1,N)]';
    YY(1:3,m)=[p(2,N)]';  
    Cen(1,m)=mean(XX(:,m));
    Cen(2,m)=mean(YY(:,m));
    if(Cen(1,m)<=0.0005&&Cen(2,m)>=-0.04973)
        l(m)=abs(Cen(2,m));
        if(dot(Current(:,m),r(:,1))>0)
            CurrentNorm(m)=norm(Current(:,m));
        else
            CurrentNorm(m)=-norm(Current(:,m));
        end
        
    elseif(Cen(1,m)<0.030581&&Cen(2,m)>=-0.07&&Cen(2,m)<-0.04973)
        l(m)=sqrt((Cen(1,m)-0.00025)^2+(Cen(2,m)+0.05)^2)+0.04973;
        if(dot(Current(:,m),r(:,2))>0)
            CurrentNorm(m)=norm(Current(:,m));
        else
            CurrentNorm(m)=-norm(Current(:,m));
        end
        
    elseif(Cen(1,m)<0.030581&&Cen(1,m)>=0.02&&Cen(2,m)>-0.1055&&Cen(2,m)<-0.069784)
        l(m)=sqrt((Cen(1,m)-0.03)^2+(Cen(2,m)+0.07)^2)+0.08579;
        if(dot(Current(:,m),r(:,3))>0)
            CurrentNorm(m)=norm(Current(:,m));
        else
            CurrentNorm(m)=-norm(Current(:,m));
        end
        
     elseif(Cen(1,m)<0.106&&Cen(1,m)>=0.02&&Cen(2,m)>-0.106&&Cen(2,m)<-0.1055)
        l(m)=sqrt((Cen(1,m)-0.02)^2+(Cen(2,m)+0.106)^2)+0.12315;
        if(dot(Current(:,m),r(:,4))>0)
            CurrentNorm(m)=norm(Current(:,m));
        else
            CurrentNorm(m)=-norm(Current(:,m));
        end
        
     elseif(Cen(1,m)<0.106&&Cen(1,m)>=0.1055&&Cen(2,m)>-0.1055&&Cen(2,m)<-0.06)
        l(m)=sqrt((Cen(1,m)-0.1055)^2+(Cen(2,m)+0.1055)^2)+0.20915;
        if(dot(Current(:,m),r(:,5))>0)
            CurrentNorm(m)=norm(Current(:,m));
        else
            CurrentNorm(m)=-norm(Current(:,m));
        end
        
      elseif(Cen(1,m)<0.1055&&Cen(1,m)>=0.0695&&Cen(2,m)>-0.0605&&Cen(2,m)<=-0.06)
        l(m)=sqrt((Cen(1,m)-0.1055)^2+(Cen(2,m)+0.0605)^2)+0.25465;
        if(dot(Current(:,m),r(:,6))>0)
            CurrentNorm(m)=norm(Current(:,m));
        else
            CurrentNorm(m)=-norm(Current(:,m));
        end  
        
        elseif(Cen(1,m)<0.07&&Cen(1,m)>=0.0695&&Cen(2,m)>-0.06&&Cen(2,m)<=-0.02)
        l(m)=sqrt((Cen(1,m)-0.07)^2+(Cen(2,m)+0.06)^2)+0.29065;
        if(dot(Current(:,m),r(:,7))>0)
            CurrentNorm(m)=norm(Current(:,m));
        else
            CurrentNorm(m)=-norm(Current(:,m));
        end  
        
        elseif(Cen(1,m)<0.07&&Cen(1,m)>=0.04&&Cen(2,m)>-0.02&&Cen(2,m)<0)
        l(m)=sqrt((Cen(1,m)-0.07)^2+(Cen(2,m)+0.02)^2)+0.33065;
        if(dot(Current(:,m),r(:,8))>0)
            CurrentNorm(m)=norm(Current(:,m));
        else
            CurrentNorm(m)=-norm(Current(:,m));
        end  
        
        elseif(Cen(1,m)<0.04&&Cen(1,m)>=0.0005&&Cen(2,m)>-0.0005&&Cen(2,m)<0)
        l(m)=sqrt((Cen(1,m)-0.04)^2+(Cen(2,m))^2)+0.36671;
        if(dot(Current(:,m),r(:,9))>0)
            CurrentNorm(m)=norm(Current(:,m));
        else
            CurrentNorm(m)=-norm(Current(:,m));
        end  
    else
        l(m)=0;
        CurrentNorm(m)=norm(Current(:,m));
    end
    
end
Jmax=max(CurrentNorm);
MaxCurrent=strcat(num2str(Jmax),'[A/m]') %ֵ
CurrentNorm1=CurrentNorm/max(CurrentNorm);%Ĺһ
figure(4)
plot(l/(c_/f),CurrentNorm1,'o')
xlabel('s/{\lambda}','fontsize',13)
ylabel('Normalized I','fontsize',13)
% % 
% Cen=[];
% XX=[p(:,Edge_(1,:))]';
% YY=[p(:,Edge_(2,:))]';  
% Cen(1,:)=(XX(:,1)+YY(:,1))/2;
% Cen(2,:)=(XX(:,2)+YY(:,2))/2;
% for m=1:EdgesTotal
%     if(Cen(1,m)<=0.0005&&Cen(2,m)>=-0.04973)
%         l(m)=abs(Cen(2,m));      
%     elseif(Cen(1,m)<0.030581&&Cen(2,m)>=-0.07&&Cen(2,m)<-0.04973)
%         l(m)=sqrt((Cen(1,m)-0.00025)^2+(Cen(2,m)+0.05)^2)+0.04973;
%     elseif(Cen(1,m)<0.030581&&Cen(1,m)>=0.02&&Cen(2,m)>-0.1055&&Cen(2,m)<-0.069784)
%         l(m)=sqrt((Cen(1,m)-0.03)^2+(Cen(2,m)+0.07)^2)+0.08579;
%      elseif(Cen(1,m)<0.106&&Cen(1,m)>=0.02&&Cen(2,m)>-0.106&&Cen(2,m)<-0.1055)
%         l(m)=sqrt((Cen(1,m)-0.02)^2+(Cen(2,m)+0.106)^2)+0.12315;
%      elseif(Cen(1,m)<0.106&&Cen(1,m)>=0.1055&&Cen(2,m)>-0.1055&&Cen(2,m)<-0.06)
%         l(m)=sqrt((Cen(1,m)-0.1055)^2+(Cen(2,m)+0.1055)^2)+0.20915;
%       elseif(Cen(1,m)<0.1055&&Cen(1,m)>=0.0695&&Cen(2,m)>-0.0605&&Cen(2,m)<=-0.06)
%         l(m)=sqrt((Cen(1,m)-0.1055)^2+(Cen(2,m)+0.0605)^2)+0.25465;
%         elseif(Cen(1,m)<0.07&&Cen(1,m)>=0.0695&&Cen(2,m)>-0.06&&Cen(2,m)<=-0.02)
%         l(m)=sqrt((Cen(1,m)-0.07)^2+(Cen(2,m)+0.06)^2)+0.29065;
%         elseif(Cen(1,m)<0.07&&Cen(1,m)>=0.04&&Cen(2,m)>-0.02&&Cen(2,m)<0)
%         l(m)=sqrt((Cen(1,m)-0.07)^2+(Cen(2,m)+0.02)^2)+0.33065;
%         elseif(Cen(1,m)<0.04&&Cen(1,m)>=0.0005&&Cen(2,m)>-0.0005&&Cen(2,m)<0)
%         l(m)=sqrt((Cen(1,m)-0.04)^2+(Cen(2,m))^2)+0.36671;
%     else
%         l(m)=0;
%      end
% end
% figure(15)
% plot(l/(c_/f),(BestI(:,2)),'o')
% xlabel('s/{\lambda}','fontsize',13)
% ylabel('Normalized I','fontsize',13)


 %% ÿζӦĵܶȲʸͼ
Index=find(t(4,:)<=1);
Triangles=length(Index);
for k=1:Triangles
    i=[0 0 0]';
    for m=1:EdgesTotal
        IE=BestI(m,2)*EdgeLength(m);
        if(TrianglePlus(m)==k)  %kڵmεԪбΪT+
            i=i+IE*RHO_Plus(:,m)/(2*Area(TrianglePlus(m)));%ϵ
        end
        if(TriangleMinus(m)==k)
            i=i+IE*RHO_Minus(:,m)/(2*Area(TriangleMinus(m)));
        end
    end
     Current(:,k)=i;      
end
l=[];
r=[0,-1,0
    0.3,-0.2,0
    -0.1,-0.36,0
    1 0 0
    0 1 0
    -1 0 0
    0 1 0
    -0.3 0.2 0 
    -1 0 0]';
%ʱ뷽Ϊ
for m=1:Triangles
    N=t(1:3,m);
    XX(1:3,m)=[p(1,N)]';
    YY(1:3,m)=[p(2,N)]';  
    Cen(1,m)=mean(XX(:,m));
    Cen(2,m)=mean(YY(:,m));
    if(Cen(1,m)<=0.0005&&Cen(2,m)>=-0.04973)
        l(m)=abs(Cen(2,m));
        if(dot(Current(:,m),r(:,1))>0)
            CurrentNorm(m)=norm(Current(:,m));
        else
            CurrentNorm(m)=-norm(Current(:,m));
        end
        
    elseif(Cen(1,m)<0.030581&&Cen(2,m)>=-0.07&&Cen(2,m)<-0.04973)
        l(m)=sqrt((Cen(1,m)-0.00025)^2+(Cen(2,m)+0.05)^2)+0.04973;
        if(dot(Current(:,m),r(:,2))>0)
            CurrentNorm(m)=norm(Current(:,m));
        else
            CurrentNorm(m)=-norm(Current(:,m));
        end
        
    elseif(Cen(1,m)<0.030581&&Cen(1,m)>=0.02&&Cen(2,m)>-0.1055&&Cen(2,m)<-0.069784)
        l(m)=sqrt((Cen(1,m)-0.03)^2+(Cen(2,m)+0.07)^2)+0.08579;
        if(dot(Current(:,m),r(:,3))>0)
            CurrentNorm(m)=norm(Current(:,m));
        else
            CurrentNorm(m)=-norm(Current(:,m));
        end
        
     elseif(Cen(1,m)<0.106&&Cen(1,m)>=0.02&&Cen(2,m)>-0.106&&Cen(2,m)<-0.1055)
        l(m)=sqrt((Cen(1,m)-0.02)^2+(Cen(2,m)+0.106)^2)+0.12315;
        if(dot(Current(:,m),r(:,4))>0)
            CurrentNorm(m)=norm(Current(:,m));
        else
            CurrentNorm(m)=-norm(Current(:,m));
        end
        
     elseif(Cen(1,m)<0.106&&Cen(1,m)>=0.1055&&Cen(2,m)>-0.1055&&Cen(2,m)<-0.06)
        l(m)=sqrt((Cen(1,m)-0.1055)^2+(Cen(2,m)+0.1055)^2)+0.20915;
        if(dot(Current(:,m),r(:,5))>0)
            CurrentNorm(m)=norm(Current(:,m));
        else
            CurrentNorm(m)=-norm(Current(:,m));
        end
        
      elseif(Cen(1,m)<0.1055&&Cen(1,m)>=0.0695&&Cen(2,m)>-0.0605&&Cen(2,m)<=-0.06)
        l(m)=sqrt((Cen(1,m)-0.1055)^2+(Cen(2,m)+0.0605)^2)+0.25465;
        if(dot(Current(:,m),r(:,6))>0)
            CurrentNorm(m)=norm(Current(:,m));
        else
            CurrentNorm(m)=-norm(Current(:,m));
        end  
        
        elseif(Cen(1,m)<0.07&&Cen(1,m)>=0.0695&&Cen(2,m)>-0.06&&Cen(2,m)<=-0.02)
        l(m)=sqrt((Cen(1,m)-0.07)^2+(Cen(2,m)+0.06)^2)+0.29065;
        if(dot(Current(:,m),r(:,7))>0)
            CurrentNorm(m)=norm(Current(:,m));
        else
            CurrentNorm(m)=-norm(Current(:,m));
        end  
        
        elseif(Cen(1,m)<0.07&&Cen(1,m)>=0.04&&Cen(2,m)>-0.02&&Cen(2,m)<0)
        l(m)=sqrt((Cen(1,m)-0.07)^2+(Cen(2,m)+0.02)^2)+0.33065;
        if(dot(Current(:,m),r(:,8))>0)
            CurrentNorm(m)=norm(Current(:,m));
        else
            CurrentNorm(m)=-norm(Current(:,m));
        end  
        
        elseif(Cen(1,m)<0.04&&Cen(1,m)>=0.0005&&Cen(2,m)>-0.0005&&Cen(2,m)<0)
        l(m)=sqrt((Cen(1,m)-0.04)^2+(Cen(2,m))^2)+0.36671;
        if(dot(Current(:,m),r(:,9))>0)
            CurrentNorm(m)=norm(Current(:,m));
        else
            CurrentNorm(m)=-norm(Current(:,m));
        end  
    else
        l(m)=0;
        CurrentNorm(m)=norm(Current(:,m));
    end
    
end
Jmax=max(CurrentNorm);
MaxCurrent=strcat(num2str(Jmax),'[A/m]') %ֵ
CurrentNorm1=CurrentNorm/max(CurrentNorm);%Ĺһ
figure(5)
plot(l/(c_/f),CurrentNorm1,'o')
xlabel('s/{\lambda}','fontsize',13)
ylabel('Normalized I','fontsize',13)
% atan(imag(Current(1,300))/real(Current(1,300)))*180/pi
% theta=angle(abs(Current(2,:))./abs(Current(1,:)))
% Phase=atan(Current(1,:).*cos(theta)+Current(2,:).*sin(theta))*180/pi
Phase=(atan(Current(1,:))+atan(Current(2,:)))/2*180/pi
J(:,3)=Phase';
% J(:,3)=J(:,3)+180;
% seq=find(J(:,3)<0);
% J(seq,3)=J(seq,3)+180;
% seq=find(J(:,3)>90);
% J(seq,3)=-J(seq,3)+180;
figure(114);plot(l/(c_/f),J(:,3),'o')
% J(:,3)=Phase';
% figure(111);plot(J(:,1),(J(:,2).*exp(1i*J(:,3)/180*pi)),'o')



%% ÿζӦĵܶȲʸͼ
Index=find(t(4,:)<=1);
Triangles=length(Index);
for k=1:Triangles
    i=[0 0 0]';
    for m=1:EdgesTotal
        IE=BestI(m,1)*EdgeLength(m);
        if(TrianglePlus(m)==k)  %kڵmεԪбΪT+
            i=i+IE*RHO_Plus(:,m)/(2*Area(TrianglePlus(m)));%ϵ
        end
        if(TriangleMinus(m)==k)
            i=i+IE*RHO_Minus(:,m)/(2*Area(TriangleMinus(m)));
        end
    end
     Current(:,k)=i;      
end
l=[];
r=[0,-1,0
    0.3,-0.2,0
    -0.1,-0.36,0
    1 0 0
    0 1 0
    -1 0 0
    0 1 0
    -0.3 0.2 0 
    -1 0 0]';
%ʱ뷽Ϊ
for m=1:Triangles
    N=t(1:3,m);
    XX(1:3,m)=[p(1,N)]';
    YY(1:3,m)=[p(2,N)]';  
    Cen(1,m)=mean(XX(:,m));
    Cen(2,m)=mean(YY(:,m));
    if(Cen(1,m)<=0.0005&&Cen(2,m)>=-0.04973)
        l(m)=abs(Cen(2,m));
        if(dot(Current(:,m),r(:,1))>0)
            CurrentNorm(m)=norm(Current(:,m));
        else
            CurrentNorm(m)=-norm(Current(:,m));
        end
        
    elseif(Cen(1,m)<0.030581&&Cen(2,m)>=-0.07&&Cen(2,m)<-0.04973)
        l(m)=sqrt((Cen(1,m)-0.00025)^2+(Cen(2,m)+0.05)^2)+0.04973;
        if(dot(Current(:,m),r(:,2))>0)
            CurrentNorm(m)=norm(Current(:,m));
        else
            CurrentNorm(m)=-norm(Current(:,m));
        end
        
    elseif(Cen(1,m)<0.030581&&Cen(1,m)>=0.02&&Cen(2,m)>-0.1055&&Cen(2,m)<-0.069784)
        l(m)=sqrt((Cen(1,m)-0.03)^2+(Cen(2,m)+0.07)^2)+0.08579;
        if(dot(Current(:,m),r(:,3))>0)
            CurrentNorm(m)=norm(Current(:,m));
        else
            CurrentNorm(m)=-norm(Current(:,m));
        end
        
     elseif(Cen(1,m)<0.106&&Cen(1,m)>=0.02&&Cen(2,m)>-0.106&&Cen(2,m)<-0.1055)
        l(m)=sqrt((Cen(1,m)-0.02)^2+(Cen(2,m)+0.106)^2)+0.12315;
        if(dot(Current(:,m),r(:,4))>0)
            CurrentNorm(m)=norm(Current(:,m));
        else
            CurrentNorm(m)=-norm(Current(:,m));
        end
        
     elseif(Cen(1,m)<0.106&&Cen(1,m)>=0.1055&&Cen(2,m)>-0.1055&&Cen(2,m)<-0.06)
        l(m)=sqrt((Cen(1,m)-0.1055)^2+(Cen(2,m)+0.1055)^2)+0.20915;
        if(dot(Current(:,m),r(:,5))>0)
            CurrentNorm(m)=norm(Current(:,m));
        else
            CurrentNorm(m)=-norm(Current(:,m));
        end
        
      elseif(Cen(1,m)<0.1055&&Cen(1,m)>=0.0695&&Cen(2,m)>-0.0605&&Cen(2,m)<=-0.06)
        l(m)=sqrt((Cen(1,m)-0.1055)^2+(Cen(2,m)+0.0605)^2)+0.25465;
        if(dot(Current(:,m),r(:,6))>0)
            CurrentNorm(m)=norm(Current(:,m));
        else
            CurrentNorm(m)=-norm(Current(:,m));
        end  
        
        elseif(Cen(1,m)<0.07&&Cen(1,m)>=0.0695&&Cen(2,m)>-0.06&&Cen(2,m)<=-0.02)
        l(m)=sqrt((Cen(1,m)-0.07)^2+(Cen(2,m)+0.06)^2)+0.29065;
        if(dot(Current(:,m),r(:,7))>0)
            CurrentNorm(m)=norm(Current(:,m));
        else
            CurrentNorm(m)=-norm(Current(:,m));
        end  
        
        elseif(Cen(1,m)<0.07&&Cen(1,m)>=0.04&&Cen(2,m)>-0.02&&Cen(2,m)<0)
        l(m)=sqrt((Cen(1,m)-0.07)^2+(Cen(2,m)+0.02)^2)+0.33065;
        if(dot(Current(:,m),r(:,8))>0)
            CurrentNorm(m)=norm(Current(:,m));
        else
            CurrentNorm(m)=-norm(Current(:,m));
        end  
        
        elseif(Cen(1,m)<0.04&&Cen(1,m)>=0.0005&&Cen(2,m)>-0.0005&&Cen(2,m)<0)
        l(m)=sqrt((Cen(1,m)-0.04)^2+(Cen(2,m))^2)+0.36671;
        if(dot(Current(:,m),r(:,9))>0)
            CurrentNorm(m)=norm(Current(:,m));
        else
            CurrentNorm(m)=-norm(Current(:,m));
        end  
    else
        l(m)=0;
        CurrentNorm(m)=norm(Current(:,m));
    end
    
end
Jmax=max(CurrentNorm);
MaxCurrent=strcat(num2str(Jmax),'[A/m]') %ֵ
CurrentNorm1=CurrentNorm/max(CurrentNorm);%Ĺһ
figure(6)
plot(l/(c_/f),CurrentNorm1,'o')
xlabel('s/{\lambda}','fontsize',13)
ylabel('Normalized I','fontsize',13)
%% ÿζӦҪģʽʸͼ ıseg
Index=find(t(4,:)<=1);
Triangles=length(Index);
CurrentVector=[];
for k=1:Triangles
    i=[0 0 0]';
    for m=1:EdgesTotal
        IE=v(m,seq(1))*EdgeLength(m);
        if(TrianglePlus(m)==k)  %kڵmεԪбΪT+
            i=i+IE*RHO_Plus(:,m)/(2*Area(TrianglePlus(m)));%ϵ
        end
        if(TriangleMinus(m)==k)
            i=i+IE*RHO_Minus(:,m)/(2*Area(TriangleMinus(m)));
        end
    end
    CurrentNorm(k)=abs(norm(i));   %ɼΪÿеĵ֮ɺʸͼ
    CurrentVector(1:2,k)=i(1:2);
end

Jmax=max(CurrentNorm);
MaxCurrent=strcat(num2str(Jmax),'[A/m]') %ֵ
CurrentNorm1=CurrentNorm/max(CurrentNorm);%Ĺһ
for m=1:Triangles
    N=t(1:3,m);
    XX(1:3,m)=[p(1,N)]';
    YY(1:3,m)=[p(2,N)]';  
end
C=repmat(CurrentNorm1,3,1);
figure(1)
h=fill(XX,YY,C); %ƶάʱֻҪZȥ
colormap gray;
colormap(flipud(colormap))
axis('equal');
rotate3d
hold on;
quiver(Center(1,:),Center(2,:),CurrentVector(1,:),CurrentVector(2,:),3,'color', 'r', 'linewidth', 1.5,'maxheadsize',1.2)
xlabel('y,m','fontsize',13)
ylabel('x,m','fontsize',13)
%% ÿζӦҪģʽʸͼ ıseg
Index=find(t(4,:)<=1);
Triangles=length(Index);
CurrentVector=[];
for k=1:Triangles
    i=[0 0 0]';
    for m=1:EdgesTotal
        IE=BestI(m,2)*EdgeLength(m);
        if(TrianglePlus(m)==k)  %kڵmεԪбΪT+
            i=i+IE*RHO_Plus(:,m)/(2*Area(TrianglePlus(m)));%ϵ
        end
        if(TriangleMinus(m)==k)
            i=i+IE*RHO_Minus(:,m)/(2*Area(TriangleMinus(m)));
        end
    end
    CurrentNorm(k)=abs(norm(i));   %ɼΪÿеĵ֮ɺʸͼ
    CurrentVector(1:2,k)=i(1:2);
end

Jmax=max(CurrentNorm);
MaxCurrent=strcat(num2str(Jmax),'[A/m]') %ֵ
CurrentNorm1=CurrentNorm/max(CurrentNorm);%Ĺһ
for m=1:Triangles
    N=t(1:3,m);
    XX(1:3,m)=[p(1,N)]';
    YY(1:3,m)=[p(2,N)]';  
end
C=repmat(CurrentNorm1,3,1);
figure(2)
h=fill(XX,YY,C); %ƶάʱֻҪZȥ
colormap gray;
colormap(flipud(colormap))
axis('equal');
rotate3d
hold on;
quiver(Center(1,:),Center(2,:),CurrentVector(1,:),CurrentVector(2,:),0.5,'color', 'r', 'linewidth', 1.5,'maxheadsize',0.5)
xlabel('y,m','fontsize',13)
ylabel('x,m','fontsize',13)
%% ÿζӦҪģʽʸͼ ıseg
Index=find(t(4,:)<=1);
Triangles=length(Index);
CurrentVector=[];
for k=1:Triangles
    i=[0 0 0]';
    for m=1:EdgesTotal
        IE=BestI(m,1)*EdgeLength(m);
        if(TrianglePlus(m)==k)  %kڵmεԪбΪT+
            i=i+IE*RHO_Plus(:,m)/(2*Area(TrianglePlus(m)));%ϵ
        end
        if(TriangleMinus(m)==k)
            i=i+IE*RHO_Minus(:,m)/(2*Area(TriangleMinus(m)));
        end
    end
    CurrentNorm(k)=abs(norm(i));   %ɼΪÿеĵ֮ɺʸͼ
    CurrentVector(1:2,k)=i(1:2);
end

Jmax=max(CurrentNorm);
MaxCurrent=strcat(num2str(Jmax),'[A/m]') %ֵ
CurrentNorm1=CurrentNorm/max(CurrentNorm);%Ĺһ
for m=1:Triangles
    N=t(1:3,m);
    XX(1:3,m)=[p(1,N)]';
    YY(1:3,m)=[p(2,N)]';  
end
C=repmat(CurrentNorm1,3,1);
figure(3)
h=fill(XX,YY,C); %ƶάʱֻҪZȥ
colormap gray;
colormap(flipud(colormap))
axis('equal');
rotate3d
hold on;
quiver(Center(1,:),Center(2,:),CurrentVector(1,:),CurrentVector(2,:),0.5,'color', 'r', 'linewidth', 1.5,'maxheadsize',0.2)
xlabel('y,m','fontsize',13)
ylabel('x,m','fontsize',13)

% %ͼ
% for m=1:EdgesTotal
%     Point1=Center(:,TrianglePlus(m));
%     Point2=Center(:,TriangleMinus(m));
%     DipoleCenter(:,m)=0.5*(Point1+Point2);
%     DipoleMoment(:,m)=EdgeLength(m)*BestI(m,1)*(-Point1+Point2); 
% end
% 
% TotalPower=0;
% %Sphere series
% 
% load('sphere');
% p1=100*p;    %sphere radius is 100 m
% M=length(t);
% for m=1:M
%     N=t(1:3,m);
%     ObservationPoint=1/3*sum(p1(:,N),2);
%     [E,H]=point(ObservationPoint,eta_,K,DipoleMoment,DipoleCenter);
%     ET=sum(E,2); HT=sum(H,2);
%     Poynting(:,m)=0.5*real(cross(ET,conj(HT)));
%     U(m)=(norm(ObservationPoint))^2*norm(Poynting(:,m));    
%     Vector1=p1(:,N(1))-p1(:,N(2));
%     Vector2=p1(:,N(3))-p1(:,N(2));
%     Area =0.5*norm(cross(Vector1,Vector2)); 
%     TotalPower=TotalPower+norm(Poynting(:,m))*Area;
%     %------------------------------
%     X(1:3,m)=[p1(1,N)]';
%     Y(1:3,m)=[p1(2,N)]';
%     Z1(1:3,m)=[p1(3,N)]';      
% end
% 
% TotalPower
% 
% figure(110)
% U=U/norm(U);
% C=repmat(U,3,1);
% h=fill3(X,Y,Z1,C);
% colormap gray;
% axis('equal')
% rotate3d on
% 
% 
% NumPoints=200;
% R=100; %pattern in m
% for ii=1:NumPoints+1
%    phi(ii)=(ii-1)*pi/(NumPoints/2);
%    y=R*sin(phi(ii))+0.053;   
%    z=R*cos(phi(ii))-0.053;   
%    ObservationPoint=[z y 0]';
% %     x=R*cos(phi(ii));   
% %     y=R*sin(phi(ii));   
% %     ObservationPoint=[x y 0]';
%    [E,H]=point(ObservationPoint,eta_,K,DipoleMoment,DipoleCenter);
%    ET=sum(E,2); HT=sum(H,2);
%    Poynting=0.5*real(cross(ET,conj(HT)));
%    W(ii)=norm(Poynting);
%    U1(ii)=(norm(ObservationPoint))^2*W(ii);
% end
% 
% Polar_=10*log10(4*pi*U1/sum(TotalPower));
% 
% GainLogarithmic=max(Polar_) %gain for the particular pattern!
% 
% %This is the standard Matlab polar plot
% phi=phi+pi;
% for i=1:size(phi,2)
%     if(phi(i)>pi*2)
%         phi(i)=phi(i)-2*pi;
%     end
% end
% figure(22)
% OFFSET=abs(min(Polar_));
% polar(phi,max(Polar_+OFFSET,0)); grid on;
% Title=strcat('Offset= ', num2str(OFFSET), ' dB');
% title(Title);

%DirectionIma(1:size(phi,2),1)=phi';
%DirectionIma(1:size(Polar_,2),2)=Polar_';